# Generated by Django 2.2.24 on 2021-09-27 09:35
from django.db import migrations
import mptt


from kinder.core.dict.models import UnitKind
from kinder.core.unit.helpers import get_ancestor_unit_by_kinds


def forwards(apps, schema_editor):
    """Обнуляем ошибочные поля Относится к МО"""
    if schema_editor.connection.alias != 'default':
        return
    Unit = apps.get_model('unit', 'Unit')
    mptt.register(Unit)
    GisdoUnit = apps.get_model('gisdo', 'GisdoUnit')
    qs  = GisdoUnit.objects.exclude(related_to_mo=None)
    for g_unit in qs:
        mo = get_ancestor_unit_by_kinds(g_unit.unit, [UnitKind.MO])
        if mo:
            g_unit.related_to_mo = None
            g_unit.save()


class Migration(migrations.Migration):

    dependencies = [
        ('gisdo', '0010_auto_20210425_1815'),
    ]

    operations = [
        migrations.RunPython(forwards, reverse_code=migrations.RunPython.noop),
    ]
